﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors;

namespace ComboEditorBindingProblem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public DataTable Table { get; set; }

        public DataTable Table2 { get; set; }

        public DataRowView Row { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            Table = new DataTable();
            Table.Columns.Add(new DataColumn("Unit"));

            Table.Rows.Add("A");
            Table.Rows.Add("B");
            Table.Rows.Add("C");

            Table2 = new DataTable();
            Table2.Columns.Add(new DataColumn("UnitValue"));

            Table2.Rows.Add("A");
            Table2.Rows.Add("B");
            Table2.Rows.Add("C");

            Row = Table2.DefaultView[1];

            xamComboEditor1.DataContext = Row;
            xamComboEditor1.ItemsSource = Table.DefaultView;

            txtBlock1.DataContext = Row;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Row["UnitValue"] = "D";  
        }

        private void Button_Click2(object sender, RoutedEventArgs e)
        {
            Row["UnitValue"] = "A";
        }
    }

    public class SelectedValueBehavior : Behavior<XamComboEditor>
    {
        public object SelectedValue
        {
            get { return (object)GetValue(SelectedValueProperty); }
            set { SetValue(SelectedValueProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SelectedValue.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SelectedValueProperty =
            DependencyProperty.Register("SelectedValue", typeof(object), typeof(SelectedValueBehavior), new PropertyMetadata(null, OnSelectedValueChanged));

        private static void OnSelectedValueChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            SelectedValueBehavior behavior = d as SelectedValueBehavior;

            if (e.NewValue != null && behavior.AssociatedObject.ItemsSource != null)
            {
                foreach (var item in behavior.AssociatedObject.ItemsSource)
                {
                    object value = null;
                    if (item is DataRowView)
                        value = (item as DataRowView)[behavior.AssociatedObject.SelectedValuePath];
                    else
                    {
                        PropertyInfo pInfo = item.GetType().GetProperty(behavior.AssociatedObject.SelectedValuePath);
                        value = pInfo.GetValue(item, null);
                    }

                    if (e.NewValue.Equals(value))
                    {
                        behavior.AssociatedObject.SelectedValue = e.NewValue;
                        return;
                    }
                }

                // if we make it here, no item was found in the itemssource so kill the selection.
                behavior.AssociatedObject.SelectedValue = null;
            }
        }

        protected override void OnAttached()
        {
            base.OnAttached();
            this.AssociatedObject.SelectionChanged += OnSelectionChanged;
        }

        void OnSelectionChanged(object sender, Infragistics.Controls.Editors.SelectionChangedEventArgs e)
        {
            this.SelectedValue = this.AssociatedObject.SelectedValue;
        }
    }
}
